var AutoFormer = {

// my variables ------------------------------------------------------------
m_LastInput: null,
m_Inputs: [],
m_Profiles: [],
m_CurrentProfile: "",
m_PrefixSep: "AF1@",
//m_IndexAfterPrefix: 4,
m_NotSavedAlarm: false,

// dummy debug dump ------------------------------------------------------------------
ddd: function(msg) 
{
  var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                       .getService(Components.interfaces.nsIConsoleService);
  consoleService.logStringMessage("_" + msg + "_");
},

//------------------------------------------------------------------------------
GetCookiePrefix: function() 
{
 var prefix = "";
 if(this.m_CurrentProfile != "")
  prefix += escape(this.m_CurrentProfile) + "#";
 prefix += this.m_PrefixSep;
 return prefix;
},


//------------------------------------------------------------------------------
ltrim: function(str) 
{
 while(str[0] == " ")
  str = str.substr(1); 
 return str;
},

//------------------------------------------------------------------------------
GetPropStr: function(id)
{
 var strings = document.getElementById("af_sb");
 return strings.getString (id);
},

//------------------------------------------------------------------------------
GetCurrentPath: function(doc) 
{
 var result = "/";
 var d = doc.domain;
 var l = doc.location.href;
 if(d.length > 3)
  result = l.substr(l.indexOf(d)+d.length);
 return result;
},
         
//------------------------------------------------------------------------------
SetCookie: function(doc, name, value, for_domain) 
{
 var today = new Date();
 var expire = new Date();
 var nDays=1024;
 expire.setTime(today.getTime() + 3600000*24*nDays);
 var cookie = name + "=" + escape(value);
 var signatureForCheck = cookie;
 cookie += ";expires=" + expire.toGMTString() + ";path=";
 if(for_domain)
  cookie += "/";
 else
  cookie += this.GetCurrentPath(doc);
 
 doc.cookie = cookie;
 if(doc.cookie.indexOf(signatureForCheck) == -1)
  this.m_NotSavedAlarm = true;
},
         
//------------------------------------------------------------------------------
ClearCookie: function(doc, name, for_domain) 
{
 var cookie = name + "=;expires=Thu, 01-Jan-70 00:00:01 GMT;path=";
 if(for_domain)
  cookie += "/";
 else
  cookie += this.GetCurrentPath(doc);
 doc.cookie = cookie;
},

//------------------------------------------------------------------------------
IsInputSaveble: function(input) 
{
 var result = true;
 var type = input.getAttribute("type");
 if (type != null)
 {
  type = type.toLowerCase();
  if (type == "button" || type == "hidden" || type == "image" || type == "submit")
   result = false;
 }
 return result;
},

//------------------------------------------------------------------------------
SaveElement: function(doc, element, for_domain)
{
 var value="";
 var to_save = true;
 var nodeName = element.nodeName.toString().toLowerCase();
 if(nodeName == "textarea")
  value = element.value;
 if(nodeName == "input")
 {
  var type = element.getAttribute("type");
  if(type != null)
   type = type.toLowerCase();
  if(type == "checkbox")
   value = element.checked;
  else
  if(type == "radio")
  {
   if(element.checked)
    value = element.value;
   else
    to_save = false;
  }
  else
   value = element.value;
 }
 if(nodeName == "select")
 {
  for(var i=0; i<element.options.length; i++)
  {
   if(element.options.item(i).selected)
    value += element.options.item(i).value + "@";
  }
 }

 //ddd("this.SaveElement::" + element.form.name + "@" + element.name + "=" + value);

 if(to_save)
  this.SetCookie(doc, 
               this.GetCookiePrefix() + element.form.name + "@" + element.name, 
               value, 
               for_domain);
},

//------------------------------------------------------------------------------

SaveForms: function(win, for_domain) 
{
 // Process self frame //
 var doc = win.document;

 //ddd("this.SaveForms::"+doc.domain);

 // save forms
 for(var f=0; f<doc.forms.length; f++)
 {
  var form = doc.forms.item(f);
  //ddd("   FORM:"+form.name);
  for(var e=0; e<form.elements.length; e++)
  {
   var element = form.elements.item(e);
   var can_save = false;
   var nodeName = element.nodeName.toString().toLowerCase();
   //ddd("      element:" + nodeName + "=" + element.name);
   if(nodeName == "textarea" || 
      nodeName == "select" || 
      (nodeName == "input" && this.IsInputSaveble(element)))
    can_save = true;
   if(can_save)
    this.SaveElement(doc, element, for_domain);
  }
 }

 // Process subframes //
 for (var i=0; i<win.frames.length; i++)
 {
  this.SaveForms(win.frames[i], for_domain);
 }
},

////////////////////////////////////////////////////////////////////////////////

OnContextPopupShowing: function()
{
 this.ddd("OnContextPopupShowing");

 var isHidden = true;

 if (gContextMenu != null)
 { 
  var targetName = gContextMenu.target.nodeName.toString().toLowerCase();
  var isSelect = (targetName == "select");
  if(gContextMenu.onTextInput || isSelect)
  {
   isHidden = false;
   this.m_LastInput = gContextMenu.target;
  }
 }
                                    
 document.getElementById("af_context").hidden = isHidden;
},

//------------------------------------------------------------------------------
OnPopupShowing: function (prefix)
{
 this.ddd("OnPopupShowing("+prefix+")");

 var disable = window._content.document.domain.length < 3;
 var cookieAbsent = window._content.document.cookie.indexOf(this.m_PrefixSep) == -1;

 document.getElementById("af_context_mi_so").setAttribute("disabled", disable);
 document.getElementById(prefix+"mi_sa").setAttribute("disabled", disable);
 document.getElementById(prefix+"mi_l" ).setAttribute("disabled", disable || cookieAbsent);
 document.getElementById(prefix+"mi_ca").setAttribute("disabled", disable || cookieAbsent);
 //--
 document.getElementById(prefix+"mi_sp").setAttribute("disabled", disable);
 //--
 this.m_Profiles = [];
 if(!disable) 
  this.UpdateProfiles4Win(window._content);
 document.getElementById(prefix+"m_lp").setAttribute("disabled", this.m_Profiles.length == 0);
 document.getElementById(prefix+"m_cp").setAttribute("disabled", this.m_Profiles.length == 0);

 if(this.m_Profiles.length)
 {
  // Load ------------------------------
  var mt_lp = document.getElementById(prefix+"mi_lp_");
 
  // remove previous profiles
  while (mt_lp.nextSibling != null)
   mt_lp.parentNode.removeChild (mt_lp.nextSibling);

  // append new profiles
  for(var i=0; i<this.m_Profiles.length; i++)
  {
    mt_lp.setAttribute("label", this.m_Profiles[i]); // fix FF3 bug 
    var mi_new = mt_lp.cloneNode(true);
    mi_new.setAttribute("hidden", false);
    mi_new.setAttribute("label", this.m_Profiles[i]);
    mi_new.setAttribute("id", prefix+"mi_lp_"+i);
    mt_lp.parentNode.appendChild (mi_new);
  }

  // Clear -----------------------------
  var mt_cp = document.getElementById(prefix+"mi_cp_");
 
  // remove previous profiles
  while (mt_cp.nextSibling != null)
   mt_cp.parentNode.removeChild (mt_cp.nextSibling);

  // append new profiles
  for(var i=0; i<this.m_Profiles.length; i++)
  {
    mt_cp.setAttribute("label", this.m_Profiles[i]); // fix FF3 bug 
    var mi_new = mt_cp.cloneNode(true);
    mi_new.setAttribute("hidden", false);
    mi_new.setAttribute("label", this.m_Profiles[i]);
    mi_new.setAttribute("id", prefix+"mi_cp_"+i);
    mt_cp.parentNode.appendChild (mi_new);
  }
 }
},

////////////////////////////////////////////////////////////////////////////////

OnSaveOne: function(event) 
{
 if (this.m_LastInput != null)
 {
  this.m_NotSavedAlarm = false;
  this.m_CurrentProfile = "";
  this.SaveElement(this.m_LastInput.ownerDocument, this.m_LastInput, event.ctrlKey);
  if(this.m_NotSavedAlarm)
   alert(this.GetPropStr("af.msg.cookie.size"));
 }
},

//------------------------------------------------------------------------------
OnSaveAll: function(event)
{
 this.m_NotSavedAlarm = false;
 this.m_CurrentProfile = "";
 this.SaveForms(window._content, event.ctrlKey);
 if(this.m_NotSavedAlarm)
  alert(this.GetPropStr("af.msg.cookie.size"));
},

//------------------------------------------------------------------------------
OnLoad: function() 
{
 this.m_CurrentProfile = "";
 this.FillForms4Win(window._content);
},

//------------------------------------------------------------------------------
OnClearAll: function(event) 
{
 this.m_CurrentProfile = "";
 this.ClearCookies(window._content, event.ctrlKey);
},

//==============================================================================
OnSaveProfile: function(event) 
{
 var profileName = this.GetPropStr("af.new.profile");

 // prompt service
 var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
 var profileObj = new Object();
 var checkObj = new Object();
 profileObj.value=profileName;
 if(promptService.prompt(window,
                         this.GetPropStr("af.prompt.save.caption"), 
                         this.GetPropStr("af.prompt.save.question"), 
                         profileObj, null, checkObj) && 
    profileObj.value.length > 0) 
 {
   profileName=profileObj.value;
   this.m_CurrentProfile = profileName;
   this.m_NotSavedAlarm = false;
   this.SaveForms(window._content, event.ctrlKey);
   if(this.m_NotSavedAlarm)
    alert(this.GetPropStr("af.msg.cookie.size"));
 }
},

//------------------------------------------------------------------------------
OnLoadProfile: function(event) 
{
 this.m_CurrentProfile = event.target.getAttribute("label");
 this.FillForms4Win(window._content);
},

//------------------------------------------------------------------------------
OnClearProfile: function(event) 
{
 this.m_CurrentProfile = event.target.getAttribute("label");
 this.ClearCookies(window._content, event.ctrlKey);
},

////////////////////////////////////////////////////////////////////////////////
UpdateProfiles4Doc: function(doc)
{
 var cookieList = doc.cookie.split(";");
 for(var i=0; i<cookieList.length; i++)
 {
  var pos = cookieList[i].indexOf("#"+this.m_PrefixSep);
  if(pos != -1) // It is AutoFormer profile!
  {
   var cookieDetailes = cookieList[i].split("#");
   var profileName = this.ltrim(unescape(cookieDetailes[0]));

   var in_list = false;
   for(p=0; p<this.m_Profiles.length; p++)
   {
    if(this.m_Profiles[p] == profileName)
    {
     in_list = true;
     break;
    }
   }

   if(!in_list)
    this.m_Profiles.push(profileName);
  }
 }
},

//------------------------------------------------------------------------------
UpdateProfiles4Win: function(win)
{
 // Process self frame //
 var doc = win.document;

 //
 this.UpdateProfiles4Doc(doc);

 // Process subframes //
 for (var i=0; i<win.frames.length; i++)
 {
  this.UpdateProfiles4Win(win.frames[i]);
 }
},

//------------------------------------------------------------------------------
ParseCookies4Doc: function(doc)
{
 var cookieList = doc.cookie.split(";");
 for(var i=0; i<cookieList.length; i++)
 {
  var cookie = this.ltrim(cookieList[i]);
  var pos = cookie.indexOf(this.GetCookiePrefix());
  if(pos == 0) // It is AutoFormer cookie!
  {
   var cookieDetailes = cookie.split("=");
   var fieldDetailes = cookieDetailes[0].split("@");
   var formName = fieldDetailes[1];
   var fieldName = fieldDetailes[2];
   var fieldValue = unescape(cookieDetailes[1]);
   this.m_Inputs.push(new Array(formName, fieldName, fieldValue));
  }
 }
},

//------------------------------------------------------------------------------
ClearCookies: function(win, for_domain)
{
 // Process self frame //
 var doc = win.document;

 var cookieList = doc.cookie.split(";");
 for(var i=0; i<cookieList.length; i++)
 {
  var cookie = this.ltrim(cookieList[i]);
  var pos = cookie.indexOf(this.GetCookiePrefix());
  if((this.m_CurrentProfile == "" && pos != -1) || // Clear all profiles
     (this.m_CurrentProfile != "" && pos == 0)     // Clear current profile only
      ) // It is AutoFormer cookie!
  {
   var cookieDetailes = cookie.split("=");
   var cookieName = cookieDetailes[0];
   this.ClearCookie(doc, cookieName, for_domain);
  }
 }

 // Process subframes //
 for (var i=0; i<win.frames.length; i++)
 {
  this.ClearCookies(win.frames[i], for_domain);
 }
},

//------------------------------------------------------------------------------
FillFields4Doc: function(doc)
{
 if (this.m_Inputs.length)
 {
  for(var f=0; f<doc.forms.length; f++)
  {
   var form = doc.forms.item(f);
   for(var e=0; e<form.elements.length; e++)
   {
    var element = form.elements.item(e);
    for(var m=0; m<this.m_Inputs.length; m++)
    {
     if(element.name == this.m_Inputs[m][1] && form.name == this.m_Inputs[m][0])
     {
      var nodeName = element.nodeName.toString().toLowerCase();
      if(nodeName == "textarea")
       element.value = this.m_Inputs[m][2];
      else
      if(nodeName == "input")
      {
       var type = element.getAttribute("type");
       if(type != null)
        type = type.toLowerCase();
       if(type == "checkbox")
        element.checked = (this.m_Inputs[m][2] == "true");
       else
       if(type == "radio")
        element.checked = element.value == this.m_Inputs[m][2];
       else
        element.value = this.m_Inputs[m][2];
      }
      else
      if(nodeName == "select")
      {
       for(var i=0; i<element.options.length; i++)
        element.options.item(i).selected = this.m_Inputs[m][2].indexOf(element.options.item(i).value + "@") != -1;
      }

      break;
     }
    }
   }
  }
 }
},

//------------------------------------------------------------------------------
FillForms4Doc: function(doc) 
{
 if(doc.domain.length > 3)
 {
  this.m_Inputs = [];
  this.ParseCookies4Doc(doc);
  this.FillFields4Doc(doc);
 }
},

//------------------------------------------------------------------------------
FillForms4Win: function(win) 
{
 // Process self frame //
 var doc = win.document;

 this.FillForms4Doc(doc);

 // Process subframes //
 for (var i=0; i<win.frames.length; i++)
 {
  this.FillForms4Win(win.frames[i]);
 }
},

////////////////////////////////////////////////////////////////////////////////
OnPageLoad: function(event) 
{
 try
 {
  if(event.originalTarget.domain != null)
  {
   // Context menu
   var menu = document.getElementById("contentAreaContextMenu");
   menu.addEventListener("popupshowing", function(){ AutoFormer.OnContextPopupShowing(); }, false);

   this.m_CurrentProfile = "";
   AutoFormer.FillForms4Doc(event.originalTarget);
  }
 }catch(e){}
},

////////////////////////////////////////////////////////////////////////////////
OnTest: function() 
{
 /*
 var str = "Stored data:\n";
 for(var i=0; i<this.m_Inputs.length; i++)
  str += (this.m_Inputs[i][0] + "@" + this.m_Inputs[i][1] + "=" + this.m_Inputs[i][2] + "\n");
 alert(str);
 */
 alert("Current cookies:\n\n" + window._content.document.cookie);
}
////////////////////////////////////////////////////////////////////////////////

};

//------------------------------------------------------------------------------
window.addEventListener("DOMContentLoaded", AutoFormer.OnPageLoad, true);

